<?php
/**
 * This file contains the ClientsController class. This class manage the clients.
 *
 * @author Elod Horvath <info@easymysoft.com>
 * @link http://www.easymysoft.com/
 * @copyright Copyright &copy; 2012 Elod Horvath
 * @license http://www.gnu.org/licenses/gpl.html
 */



class clientsController extends Controller{
			
	
			
	public function access(){
		
		return array(
		    'controller'=>'clients',
			'actions'=>array()
		);		
				
	}
	
	
    public function actionIndex(){
		
	    $model = new Clients;						
		$results = $model->findAll();		
							   
	    $this->render('index',array(			    	    		    		    		    
		    'results'=>$results,			
	    )); 	   
			
		
	}
	
	
	
	public function actionCreate(){
		
	    $model = new Clients;
		$errors = null;		
								
		if(isset($_POST['Clients'])){
			
			$model->Attributes = $_POST['Clients'];
			$model->Attributes['id'] = md5(time().rand());	
					
			// Validate the form
			$validator = new Validator();
			$validator->required($model->Attributes['name']);
			$validator->required($model->Attributes['email']);
			$validator->email($model->Attributes['email']);
			$validator->xmlUnique($model,$model->Attributes['email'],array('email','id'));//(modelname,attr,array(attrname,isupdate))
			
			if($validator->checkErrors()){ 
			    $errors = $validator->displayErrors();
			}else{
			    $model->save(); 
			    header("Location: ".ROOT_URL."/clients/create.html");	
			}									
						
		}				
		
		
		$this->render('create',array(
		    'model'=>$model,		    
			'errors'=>$errors
		));	
		
	}
	
	
	
	public function actionUpdate(){
		
	    $model = new Clients;	
		$errors = null;
		$result = $model->find(array('id'=>$_GET['id']));
		
		if(isset($_POST['Clients'])){
			
			$model->Attributes = $_POST['Clients'];				
			
            //Validate the file
            $validator = new Validator();
            $validator->isFwritable($model->xmlFile());
			// Validate the form
			$validator->required($model->Attributes['name']);
			$validator->required($model->Attributes['email']);
			$validator->email($model->Attributes['email']);
			$validator->xmlUnique($model,$model->Attributes['email'],array('email','id'));
			
			if($validator->checkErrors()){ 
			    $errors = $validator->displayErrors();
			}else{
			    $model->update(array('id'=>$_GET['id'])); 
			    header('Location: '.ROOT_URL.'/clients/update/'.filter_var($_GET['id'], 
			    FILTER_SANITIZE_SPECIAL_CHARS).'.html');	
			}									
						
		}
		
		$this->render('update',array(
		    'result'=>$result,		    
			'errors'=>$errors
		));	
		
		
	}
	
	
	public function actionDelete(){
		
	    $model=new Clients;	
		$model->delete(array('id'=>$_GET['id']));	
		header("Location: ".ROOT_URL."/clients/index.html");
		
	}


}

?>
