<?php
/**
 * This file contains the SiteController class. This class manage the login process.
 *
 * @author Elod Horvath <info@easymysoft.com>
 * @link http://www.easymysoft.com/
 * @copyright Copyright &copy; 2012 Elod Horvath
 * @license http://www.gnu.org/licenses/gpl.html
 */



class siteController extends Controller{

    
	public function access(){
		
		return array(
		    'controller'=>'site',
			'actions'=>array()
		);		
				
	}
	
	
    public function actionIndex(){
		
	    
		$errors = null;		
		
		if(isset($_POST['login'])){
			
			// Validate the form---------------------------------------------------------------------
			$validator = new Validator();
			$validator->required($_POST['username']);		
			$validator->required($_POST['password']);
			$validator->compareUP($_POST['username'], APP_USERNAME);					
			$validator->compareUP($_POST['password'], APP_PASSWORD);
			
			if($validator->checkErrors()){
			    $errors = $validator->displayErrors();	
		    }else{			   
				$username = filter_var($_POST['username'], FILTER_SANITIZE_SPECIAL_CHARS);	
				$pms = new Pms();		    				
				$pms->logged($username);
				header("Location: ".ROOT_URL."/clients/index.html");
			}						
			//Validation end-------------------------------------------------------------------------
									
		}
		
		
	    $this->render('index',array(
		    'errors'=>$errors
		));
		
	}
	
	
	//Logout
	
	public function actionLogout(){				
		
	    session_destroy();
		header('Location: index.html');    	
		
	}

}
?>
