<?php
/**
 * This is the bootstrap file.
 *
 * @author Elod Horvath <info@easymysoft.com>
 * @link http://www.easymysoft.com/
 * @copyright Copyright &copy; 2012 Elod Horvath
 * @license http://www.gnu.org/licenses/gpl.html
 */




//Manage error reporting

function set_debug(){
	
    if(DEV_ENV == 'yes'){
		
	    error_reporting(E_ALL);	
		ini_set('display_errors','On');
		
	}else{
		
	    error_reporting(E_ALL);
	    ini_set('display_errors','Off');
	    ini_set('log_errors', 'On');
	    ini_set('error_log', APP_PATH.'/tmp/logs/error.log');	
		
	}
	
}


//Disable magic quotes

function disable_magic_quotes(){
	
	if (get_magic_quotes_gpc()) {
		
         function stripslashes_gpc($value){
             $value = stripslashes($value);
         }
		 
         array_walk_recursive($_GET, 'stripslashes_gpc');
         array_walk_recursive($_POST, 'stripslashes_gpc');
         array_walk_recursive($_COOKIE, 'stripslashes_gpc');
         array_walk_recursive($_REQUEST, 'stripslashes_gpc');
		 
    }
 	
}


//Unset register globals
function unregister_globals() {
     if (ini_get('register_globals')) {
         $array = array('_REQUEST', '_SESSION', '_SERVER', '_ENV', '_FILES');
         foreach ($array as $value) {
             foreach ($GLOBALS[$value] as $key => $var) {
                 if ($var === $GLOBALS[$key]) {
                     unset($GLOBALS[$key]);
                 }
             }
         }
     }
 }
 
 

//Router - Check controller and action from url and load them
function router(){
	 
    if(isset($_GET['c']) && isset($_GET['a'])){
		
		$c = filter_input(INPUT_GET, 'c', FILTER_SANITIZE_STRING);
		$a = filter_input(INPUT_GET, 'a', FILTER_SANITIZE_STRING);
		 		
	    $controller = $c.'Controller';	
		$action     = 'action'.ucfirst($a);
		
		 
		if(!class_exists($controller) || !method_exists($controller, $action)){	
		    $error = ERROR.': '.THIS_CLASS_OR_FUNCTION_IS_NOT_EXISTS;	
		    die($error);	
		}				
						
		$dispatch = new $controller($c);	
		$dispatch->$action();									
		
	}else{
	     
		$dispatch = new siteController('site');
		$dispatch->actionIndex();	
		 	
	}
	 
}


//Load the classes
function autoloader($class){
		
    if(file_exists(SYS_PATH.'/'.$class.'.php')){
		
	    require_once(SYS_PATH.'/'.$class.'.php');	
		
	}
	
	
	if(file_exists(APP_PATH.'/controllers/'.$class.'.php')){
		
	    require_once(APP_PATH.'/controllers/'.$class.'.php');	
		
	}
	
	if(file_exists(APP_PATH.'/models/'.$class.'.php')){
		
	    require_once(APP_PATH.'/models/'.$class.'.php');	
		
	}
	
	if(file_exists(SYS_PATH.'/vendor/Swift/lib/swift_required.php')){
		
	    require_once(SYS_PATH.'/vendor/Swift/lib/swift_required.php');	
		
	}
	
	
			
}

//Call the defined functions

spl_autoload_register('autoloader');
set_debug();
disable_magic_quotes();
unregister_globals();
router();

?>
