<?php
/**
 * This file contains the XMLModel class. The XMLModel handling with XML files.
 *
 * @author Elod Horvath <info@easymysoft.com>
 * @link http://www.easymysoft.com/
 * @copyright Copyright &copy; 2012 Elod Horvath
 * @license http://www.gnu.org/licenses/gpl.html
 */



class XMLModel{


    public $Attributes; // Attributes array from form request.
	

    public function save(){
		
	    $xml = simplexml_load_file($this->xmlFile()); // Load xml file
		$xmlAttributes = $this->xmlAttributes(); //Add xml attributes(nodes...) from model.
		$new_child = $xml->addChild($xmlAttributes['child']); // Add child
		
		foreach($this->Attributes as $kAttribute=>$vAttribute){
											        			    										
		    $new_child->addChild($kAttribute,filter_var($vAttribute, FILTER_SANITIZE_STRING));		    
			
		}
		
		$xml->asXML($this->xmlFile());	
		
	}
	
	
	
	public function findAll(){
        				
		$results=array();
	    $xml = simplexml_load_file($this->xmlFile());		
				
		foreach($xml as $result){				
			$results[] = $result;					
		}				
																		
				
		return $results;
	}
	
	
	//find all with pagination
	public function findAllP($per_page){
        
		$page=isset($_GET['page']) ? $_GET['page'] : '';
		$curr_page = filter_var($page, FILTER_SANITIZE_STRING);
		$results=array();
	    $xml = simplexml_load_file($this->xmlFile());		
				
		foreach($xml as $result){				
			$results[] = $result;					
		}				
														
		$results = array_slice($results,($curr_page-1)*$per_page,$per_page);		
				
		return $results;
	}
	
			
	
	public function countXMLRows(){
		
	    $xml = simplexml_load_file($this->xmlFile());
		$xmlAttributes = $this->xmlAttributes();	
		return count($xml->$xmlAttributes['child']);
		
	}
	
	
	
	public function find($attributes){
		
	    $xml = simplexml_load_file($this->xmlFile());
		$xmlAttributes = $this->xmlAttributes();
		$attr = null;
		
		foreach($attributes as $kAttribute=>$vAttribute){
		    $vAttribute=filter_var($vAttribute, FILTER_SANITIZE_STRING);
		    $attr .= "[$kAttribute='$vAttribute']";
		}
		
	
		$search = $xml->xpath("/".$xmlAttributes['parent']."/".$xmlAttributes['child']."$attr");
				
		$results = $search[0];
		
		return $results;
		
	}
	
	
	
	public function update($attributes){
		
	    $xml = simplexml_load_file($this->xmlFile());
            $xmlAttributes = $this->xmlAttributes();
	    $attr = null;
		
	    foreach($attributes as $kAttribute=>$vAttribute){
		$vAttribute=filter_var($vAttribute, FILTER_SANITIZE_STRING);
		$attr .= "[$kAttribute='$vAttribute']";
	    }
		
		
	    $results = $xml->xpath("/".$xmlAttributes['parent']."/".$xmlAttributes['child']."$attr");
		
	    foreach($results as $result){
			
		foreach($this->Attributes as $kAttribute=>$vAttribute){					    
			$result->$kAttribute=$vAttribute;    			
		}
			
            }
						
	    $xml->asXML($this->xmlFile());	
					
	}
	
	
	
	public function delete($attributes){
		
	    $xml = simplexml_load_file($this->xmlFile());
		$xmlAttributes = $this->xmlAttributes();
		$attr = null;
		
		foreach($attributes as $kAttribute=>$vAttribute){
		    $vAttribute=filter_var($vAttribute, FILTER_SANITIZE_STRING);
		    $attr .= "[$kAttribute='$vAttribute']";
		}
		
		$results = $xml->xpath("/".$xmlAttributes['parent']."/".$xmlAttributes['child']."$attr");		
		$node = dom_import_simplexml($results[0]); 
        $node->parentNode->removeChild($node);				
		
		$xml->asXML($this->xmlFile());	
	
		
	}
	
	
	
	public function pagination($link,$per_page){
				 		 		 
	     $xml = simplexml_load_file($this->xmlFile());		 
		 $count = ceil($xml->count()/$per_page);		 
		 
		 for($i=1;$i<=$count;$i++){
		     			 
			 $pnums[] = "<a id=".$i." href='".ROOT_URL."/$link/$i.html'>$i</a> ";
		 }
		 
		 if($count < 2)
		     $pnums = array();
			 	 
		 return $pnums;
		
	}



}
?>
